#!/usr/bin/python2.7
import os
import random

page_size = 1024

SHIFT = 10
OFFSET_MASK = (2**10 - 1)
VPN_MASK = ((2**4 -1) << SHIFT)
PTBR = 128 * 1024
PTE_SIZE = 4

page_table = {} 

print "Page Table:"

page_table_addr = PTBR

for i in range(12):
    page_table[i] = 256 * 1024 + (random.randint(0,1000)) * page_size
    print page_table_addr, i, page_table[i]
    page_table_addr += 4
print

def pprint(x):
    for e in x:
        print e,
    print

# Translate virtual num into physical num
def translate(x):
    arr = []

    # Figure out VPN
    VPN = (x & VPN_MASK) >> SHIFT
    #print "VPN:", VPN

    # Figure out offset
    offset = (x & OFFSET_MASK)
    #print "offset:", offset

    PTEAddr = PTBR + (VPN * PTE_SIZE) 
    arr.append(PTEAddr)

    phy_addr = page_table[VPN] + offset
    #print phy_addr

    arr.append(phy_addr)
    return arr

def process(line):
    line = line.strip()
    line = line.replace(",", " ")
    strs = line.split(" ")

    nums = []

    for x in strs:
        if x != " ":
            if x.isdigit():
                nums.append(int(x))

    if (strs[1] == "add"):
        pprint(translate(nums[0]))
        return
    else:
        for x in nums:
            pprint(translate(x))

for line in open("input", "r"):
    line = line.strip()
    print line
    process(line)
    print
